<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Book list</title>
  <link rel="stylesheet" href="/public/styles/main.css">
  <style>
    #book-list {
      width: 100%;
    }
    #book-list li {
      width: 400px;
      display: block;
      float: none;
      margin: 5px auto;
      background-color: #eee;
      border-radius: 7px;
      padding: 5px 10px;
      color: #000;
    }
    #book-list li div {
      margin: 5px 0;
    }
    .flex {
        display: flex;
        justify-content: space-between;
        align-items: center;
    }
  </style>
</head>
<body>
<header>
  <nav>
    <ul>
      <li><a href="/books.html">Books</a></li>
      <li><a href="/new-book.html">Add new book</a></li>
    </ul>
  </nav>
  <div id="logo"><a href="/">Logo</a></div>
</header>
<main>
  <div class="main-container">
    <h1>Book list</h1>
    <ul id="book-list"></ul>
  </div>
</main>
<script>
  const list = document.getElementById('book-list')

  function createListItem(id, name, pages) {
    return `
    <li>
      <div class="flex">
        <span>Book name:</span><span>${name}</span>
      </div>
      <div class="flex">
        <span>Pages:</span><span>${pages}</span>
      </div>
      <div class="flex">
        <button type="button" onclick="updateBook(${id})">Update</button>
        <button type="button" onclick="deleteBook(${id})">Delete</button>
      </div>
    </li>
    `
  }

  function deleteBook(id) {
    fetch(`api/book/delete/${id}`, {
      method: 'DELETE',
    })
      .then(() => {
        loadBookList()
      })
  }

  function updateBook(id) {
    const name = prompt('Enter book name', '');
    const pages = prompt('Enter pages count');

    const data = {
      name,
      pages,
    }

    fetch(`api/book/update/${id}`, {
      method: 'PUT',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify(data)
    })
      .then(
        () => loadBookList(),
        () => alert('Network Error!')
      )
  }

  function loadBookList() {
    fetch('api/book')
      .then((data) => data.json())
      .then(({ data }) => {
        const items = data.map(({ id, name, pages }) =>
          createListItem(id, name, pages))
        list.innerHTML = items.join('')
      })
  }

  loadBookList()
</script>
</body>
</html>